/*
Scrivere un programma per la gestione degli iscritti a un miniclub e delle loro attivit.
Gli iscritti sono caratterizzati da: nominativo, codice identificativo, fascia et (0=3-5 anni,
1=6-7 anni, 2=8-10 anni).
Le attivit sono caratterizzate da: codice identificativo iscritto, codice animatore, tipo di
attivit (0..3).
Gli iscritti sono inseriti in un vettore di 3 liste, una per ogni fascia di et.
Le attivit sono inserite in una tabella allocata dinamicamente avente 4 righe, una per ogni
tipo di attivit.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento nel vettore di liste di un nuovo iscritto;
2. Eliminazione di un iscritto dopo la sua visualizzazione ( chiedere codice
identificativo e fascia det);
3. Inserimento ordinato rispetto al codice animatore di una nuova attivit;
4. Visualizzazione delle attivit degli iscritti fatte con un certo animatore (chiedere il
codice dellanimatore);
5. Salvataggio su file delle attivit;
All'avvio del programma inizializzare la tabella delle attivit leggendo da file le attivit
precedentemente salvate.
Liberare la memoria allocata dinamicamente.

*/

#include <stdio.h>
#include <stdlib.h>


typedef struct {
        int iscritto,animatore;
        int tipo;
        }attivita;
 
 typedef struct {
         char nominativo[80];
         int codice,fascia;
         } iscritto;
         
 struct atomo {
        iscritto dato;
        struct atomo *next;
        };
        
void ins_iscritto(struct atomo *L[3]);
void elimina(struct atomo *L[3]);
void leggi(attivita *a);
void ins_attivita(attivita **R, int *n, attivita a);
void visualizza(attivita *T[4], int N[4]);
void salva(attivita *T[4], int N[4]);
void inizializza(attivita *T[4], int N[4]);

main() {
       attivita *TA[4],a;
       int NA[4];
       struct atomo *VL[3],*ax;
       int i, sc;
       
       /* inizializzazione */
         for(i=0;i<4;i++)
          {
            TA[i]=NULL;
            NA[i]=0;
            }
         for(i=0;i<3;i++)
           VL[i]=NULL;
          
         inizializza(TA,NA);
         
         do {
             printf("Quale operazione ?\n");
             printf("1) Nuovo iscritto\n2) Elimina iscritto\n");
             printf("3) Nuova attivita'\n4) Vis. attivita per animatore\n");
             printf("5) Salva attivita'\n0) fine\n\n");
             scanf("%d",&sc);
             switch(sc) {
               case 1:  /* ins. iscritto */
                          ins_iscritto(VL);
                          break;
              case 2:   /* eliminazione di un iscritto*/
                        elimina(VL);
                        break;
             case 3:    /* ins. attivita' */
                       leggi(&a);
                       i=a.tipo;
                       ins_attivita(&TA[i],&NA[i],a);
                       break;
             case 4:   visualizza(TA,NA);
                       break;
             case 5:   salva(TA,NA);
                       break;
             default:; }
         } while(sc!=0);
         
         /* liberiamo la memoria */
         for(i=0;i<4;i++)
           free(TA[i]);
           
         for(i=0;i<3;i++)
           while(VL[i]!=NULL)
            { ax=VL[i];
              VL[i]=ax->next;
              free(ax);
              }
}


void ins_iscritto(struct atomo *L[3])
{
     struct atomo *aux;
     int i;
     
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL) return;
     printf("Nominativo: ");
     scanf("%s",aux->dato.nominativo);
     printf("Codice iscritto: ");
     scanf("%d",&aux->dato.codice);
     printf("Fascia (0..2) ");
     scanf("%d",&aux->dato.fascia);
     i=aux->dato.fascia;
     aux->next=L[i];
     L[i]=aux;
}


void elimina(struct atomo *L[3])
{
     int codice,fascia;
     struct atomo *l1,*l2;
     
     printf("Fascia: ");
     scanf("%d",&fascia);
     if(L[fascia]==NULL)
        { printf("Lista vuota\n");
          return;
        }
     printf("Codice iscritto: ");
     scanf("%d",&codice);
     
     if(L[fascia]->dato.codice==codice)
      /* trovato in testa */
      { printf("Nominativo: %s\n",L[fascia]->dato.nominativo);
        l1=L[fascia];
        L[fascia]=l1->next;
        free(l1);
        return;
      }
     /* cerchiamo in posizione successiva alla prima*/
     l2=L[fascia];
     l1=l2->next;
     while(l1!=NULL)
        if(l1->dato.codice==codice)
         /* trovato*/
         { printf("Nominativo: %s\n",l1->dato.nominativo);
           l2->next=l1->next;
           free(l1);
           return;
         }
       else {l2=l1;
             l1=l1->next;
             }
   /* se siamo arrivati in questo punto l'elemento
      non e' stato trovato */
      printf("L'elemento non e' stato trovato\n");
}
      
      
void leggi(attivita *a)
{
   printf("Codice iscritto: ");
   scanf("%d",&a->iscritto);
   printf("Codice animatore: ");
   scanf("%d",&a->animatore);
   printf("Tipo attivita' (0..3) ");
   scanf("%d",&a->tipo);
}
  
void ins_attivita(attivita **R, int *n, attivita a)
{
     attivita *Ra;
     int i,p;
     
     /* inserimento ordinato rispetto al codice animatore */
     Ra=(attivita *) realloc(*R,sizeof(attivita)*(*n+1));
     if(Ra==NULL) return;
     *R=Ra;
     
      for(p=0;p<*n;p++)
        if(a.animatore< Ra[p].animatore)
          break;
          
      for(i=*n;i>p;i--)
         Ra[i]=Ra[i-1];
         
      Ra[p]=a;
      (*n)++;
}
   
void visualizza(attivita *T[4], int N[4])
{
     int i,j;
     int animatore;
     
     printf("Codice animatore: ");
     scanf("%d",&animatore);
     for(i=0;i<4;i++)
      for(j=0;j<N[i];j++)
     if(T[i][j].animatore==animatore)
           { printf("Codice iscritto: %d\n",T[i][j].iscritto);
             printf("Tipo attivita': %d\n\n",T[i][j].tipo);
           }
}
      
    
void salva(attivita *T[4], int N[4])
{
     FILE *pf;
     int i;
     
     pf=fopen("attivita.at","w");
     if(pf) {
              for(i=0;i<4;i++)
                fwrite(T[i],sizeof(attivita),N[i],pf);
              fclose(pf);
              }
}

void inizializza(attivita *T[3], int N[3])
{
     FILE *p;
     attivita a;
     int i;
     
     p=fopen("attivita.at","r");
     if(p) {
             while(fread(&a,sizeof(attivita),1,p)!=0)
                {
                 i=a.tipo;
                 ins_attivita(&T[i],&N[i],a);
                 }
             fclose(p);
             }
}
     
     

 
        
