/*
Scrivere un programma per la gestione dei dipendenti e delle loro attivit.
I dipendenti sono caratterizzati da: cognome, nome, matricola e tipo di qualifica (0..4).
Le attivit sono caratterizzate da: matricola dipendente, data, codice attivit (0..9).
I dipendenti sono inseriti in un vettore di 5 liste, una per ogni tipo di qualifica.
Le attivit sono inserite in una tabella allocata dinamicamente avente 10 righe, una per ogni codice attivit.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento nel vettore di liste di un nuovo dipendente;
2. Ricerca di un dipendente ( chiedere matricola e tipo di qualifica);
3. Inserimento di una nuova attivit;
4. Eliminazione di unattivit dopo averla visualizzata (chiedere la matricola e il codice attivit);
5. Salvataggio su file delle attivit;
All'avvio del programma inizializzare la tabella delle attivit leggendo da file le attivit precedentemente salvate.
Liberare la memoria allocata dinamicamente.
*/



#include <stdio.h>
#include <stdlib.h>

typedef struct {
        long matricola;
        char data[12];
        int codice;} attivita;
typedef struct { 
        char nome[80];
        long matricola;
        int tipo;
} dipendente;

struct atomo {
       dipendente dato;
        struct atomo *pros;
        };

void leggi_dip(dipendente *d);        
void ins_dipendente(struct atomo **tl, dipendente d);
void ricerca (struct atomo *tl, long matricola);
void ins_attivita(attivita *T[10], int N[10]);
void elimina_attivita(attivita *T[10], int N[10]);
void salva(attivita *T[10], int N[10]);
void inizializza(attivita *T[10], int N[10]);


main() {
       attivita *T[10];
       int N[10], i, scelta;
       struct atomo *L[5],*a;
       dipendente d;
       long matricola;
       
       /* inizializzazione*/
        for(i=0;i<10;i++)
         { T[i]=NULL;
           N[i]=0;
           }
        
        for(i=0;i<5;i++)
         L[i]=0;
         
         inizializza(T,N);
         
         do {
             printf("Scegli\n");
             printf("1 Ins. dipendente\n2 Ricerca dipendente\n");
             printf("3 Ins attivita'\n4 Elimina attivita'\n");
             printf("5 Salva attivita'\n");
             printf("0 fine\n");
             scanf("%d",&scelta);
             switch(scelta) {
               case 1:     leggi_dip(&d);
                           i=d.tipo;
                           ins_dipendente(&L[i],d);
                           break;
               case 2:     printf("Tipo di qualifica (0..4) ");
                           scanf("%d",&i);
                           printf("Matricola: ");
                           scanf("%ld",&matricola);
                           ricerca(L[i],matricola);
                           break;
             case 3:      ins_attivita(T,N);
                          break;
             case 4:      elimina_attivita(T,N);
                          break;
             case 5:      salva(T,N);
                          break;
             default:; }
             } while(scelta!=0);
         
         for(i=0;i<10;i++)
            free(T[i]);
            
         for(i=0;i<5;i++)
           while(L[i]!=NULL)
            {a=L[i];
             L[i]=a->pros;
             free(a);
             }
}
                           
void leggi_dip(dipendente *d)
{
     printf("Nome: ");
     scanf("%s",d->nome);
     printf("Matricola: ");
     scanf("%ld",&d->matricola);
     printf("Tipo qualifica (0..4) ");
     scanf("%d",&d->tipo);
 }      
 
void ins_dipendente(struct atomo **tl, dipendente d)
{
     struct atomo *a;
     
     a=(struct atomo *) malloc ( sizeof(struct atomo));
     if(a==NULL)
      return;
      
     a->dato=d;
     a->pros=*tl;
     *tl=a;
}
 
void ricerca (struct atomo *tl, long matricola)
{
     while(tl!=NULL)
        if(tl->dato.matricola==matricola)
          /* trovato*/
           {  printf("Nome: %s\n",tl->dato.nome);
              return;
           }
        else tl=tl->pros;
}
     
void ins_attivita(attivita *T[10], int N[10])
{
      attivita a,*R;
      int i;
      
      printf("Matricola: ");
      scanf("%ld",&a.matricola);
      printf("Data: ");
      scanf("%s",a.data);
      printf("Codice attivita' (0..9) ");
      scanf("%d",&a.codice);
      
      i=a.codice;
      
      R= (attivita *) realloc(T[i],sizeof(attivita)*(N[i]+1));
      if(R==NULL)
         return;
      T[i]=R;
      R[N[i]]=a;
      N[i]++;
}
      
void elimina_attivita(attivita *T[10], int N[10])
{
  int i,p,codice;
  long matricola;
  
  printf("Codice attivita' (0..9) ");
  scanf("%d",&codice);
  printf("Matricola: ");
  scanf("%ld",&matricola);
  
  /* ricerca */
    for(p=0;p<N[codice];p++)
      if(T[codice][p].matricola==matricola)
         /* trovato*/
          break;
          
    if(p<N[codice]) 
    { /* se trovato*/
      
      printf("Data : %s\n", T[codice][p].data);
                    
     for(i=p;i<N[codice]-1;i++)
        T[codice][i]=T[codice][i+1];
    
    N[codice]--;
    T[codice]=(attivita *) realloc(T[codice],sizeof(attivita)*N[codice]);
               
    
    }
}
 
void salva(attivita *T[10], int N[10])
{
     FILE *pf;
     int i;
     
     pf=fopen("attivita.att","w");
     if(pf) {
              for(i=0;i<10;i++)
                fwrite(T[i],sizeof(attivita),N[i],pf);
              fclose(pf);
              }
 }
void inizializza(attivita *T[10], int N[10])
{
     FILE *p;
     attivita a,*R;
      int i;
      
      p=fopen("attivita.att","r");
      if(p) {
              while(fread(&a,sizeof(attivita),1,p)!=0)
                { 
                 i=a.codice;
                 R= (attivita *) realloc(T[i],sizeof(attivita)*(N[i]+1));
                 if(R==NULL)
                  break;
                 T[i]=R;
                 R[N[i]]=a;
                 N[i]++;
                }
               fclose(p);
       }
} 

